openlink/core/urls.py
from django.urls import path, register_converter
from openlink.core import views
from openlink.core.views import items, mapping, projects, publish, tools, users


class FloatConverter:
    regex = r"[\d\.\d]+"

    def to_python(self, value):
        return float(value)

    def to_url(self, value):
        return "{}".format(value)


register_converter(FloatConverter, "float")


app_name = "core"
urlpatterns = [
    path("", projects.projects, name="home"),
    path("about/", views.home, name="about"),
    path("profile/<username>/", views.get_user_profile, name="user-profile"),
    path("contact/", views.contact, name="contact"),
    # projects creation
    path("projects", projects.projects, name="projects"),
    path("projects/new", projects.new_project, name="projects-new"),
    path("projects/add", projects.add_project, name="projects-add"),
    # projects tools
    path(
        "projects/<int:project_id>/tools",
        tools.list_tools_project,
        name="tools-project",
    ),
    path(
        "projects/<int:project_id>/tools/new",
        tools.select_connector_project,
        name="select-connector-project",
    ),
    path(
        "projects/<int:project_id>/tools/<str:connector>",
        tools.add_tool_project,
        name="add-tool-project",
    ),
    path(
        "projects/<int:project_id>/tools/<int:tool_id>/edit_tool",
        tools.ToolUpdate.as_view(),
        name="tools-edit-project",
    ),
    path(
        "projects/<int:project_id>/tool/<int:tool_id>",
        tools.get_tool_info_project,
        name="tool-project",
    ),
    path(
        "projects/<int:project_id>/delete/tool/<int:pk>",
        tools.delete_tool,
        name="delete_tool",
    ),
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool",
        tools.choose_tool,
        name="choose_tool_project",
    ),
    # projects editing
    path(
        "projects/<int:project_id>/edit",
        items.ProjectUpdate.as_view(),
        name="edit-project",
    ),
    path(
        "projects/<int:project_id>/add_user_mapping",
        users.add_user_mapping,
        name="add_user_mapping",
    ),
    path(
        "projects/<int:project_id>/manage_user",
        mapping.mapping_project_user,
        name="mapping_project_user",
    ),
    path(
        "projects/<int:project_id>/delete_user_mapping/<str:pk>",
        mapping.delete_user_mapping,
        name="delete_user_mapping",
    ),
    path("projects/<int:project_id>/", projects.details, name="projects-details"),
    path(
        "projects/<int:project_id>/delete/<str:data_type>/<int:pk>",
        projects.delete,
        name="delete",
    ),
    path(
        "projects/<int:project_id>/add_investigation",
        items.add_investigation,
        name="add-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/edit",
        items.InvestigationUpdate.as_view(),
        name="edit-investigation",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/add_study",
        items.add_study,
        name="add-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/edit",
        items.StudyUpdate.as_view(),
        name="edit-study",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/add_assay",
        items.add_assay,
        name="add-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/edit",
        items.AssayUpdate.as_view(),
        name="edit-assay",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/add_data",
        items.add_data,
        name="add-data",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/edit",
        items.DataUpdate.as_view(),
        name="edit-data",
    ),
    # project investigation map_id item
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/datasets",
    #     mapping.datasets,
    #     name="datasets",
    # ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/data/<int:data_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/assay/<int:assay_id>/<int:tool_id>/<path:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/datas",
        mapping.datas,
        name="datas",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/study/<int:study_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/assays",
        mapping.assays,
        name="assays",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/studies",
        mapping.studies,
        name="studies",
    ),
    # project investigation map_id select mapping
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:map_id>/select_data_mapping",
        mapping.select_data_mapping,
        name="select_data_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<int:tool_id>/<str:map_id>/select_assay_mapping",
        mapping.select_assay_mapping,
        name="select_assay_mapping",
    ),
    # publish
    path(
        "project/<int:project_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "project/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_tool_for_publish",
        tools.choose_tool_for_publish,
        name="choose_tool_for_publish_project",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_object_to_publish",
        publish.choose_object_to_publish,
        name="choose_object_to_publish",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/update/<path:saved_doi>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # testé quelle route est uttilisé pour choose_meta
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_metadata",
        publish.choose_metadata,
        name="choose_metadata",
    ),
    # path(
    #     "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_non_linked_object",
    #     mapping.choose_non_linked_object,
    #     name="choose_non_linked_object",
    # ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_non_linked_object",
        mapping.choose_non_linked_object_tool,
        name="choose_non_linked_object_tool",
    ),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    # path('projects/<int:id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<str:tool>/<int:tool_id>/choose_object_to_publish', projects.choose_object_to_publish, name='choose_object_to_publish'),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:pk>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(
        "projects/<int:project_id>/investigations/<int:investigation_id>/<str:data_type>/<int:tool_id>/<path:map_id>/choose_option_mapping",
        mapping.choose_option_mapping,
        name="choose_option_mapping",
    ),
    path(

openlink/urls.py
import debug_toolbar

# from openlink.core.admin import admin_site
from django.contrib import admin
from django.contrib.auth import views
from django.urls import include, path
from rest_framework import routers

from openlink import log_manager
from openlink.core.views import api

admin.site.site_header = "OPENLINK Database administration"
admin.site.site_title = "OPENLINK administration"
admin.site.index_title = "OPENLINK Site Administration"

router = routers.DefaultRouter()
router.register(r"taskinfo", api.TaskinfoViewSet, basename="taskinfo")
router.register(r"access_mapping", api.MappingViewSet, basename="access_mapping")

urlpatterns = [
    path("__debug__/", include(debug_toolbar.urls)),
    path("", include("openlink.core.urls")),
    path("admin/", admin.site.urls),
    path("accounts/login/", log_manager.login_page, name="login"),
    path("accounts/logout/", log_manager.custom_logout, name="logout"),
    path("accounts/", include("django.contrib.auth.urls")),
    path("django-rq/", include("django_rq.urls")),
    path("oidc/", include("mozilla_django_oidc.urls")),
    path("api/", include(router.urls)),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
]

openlink/core/views/api.py
import datetime
import json
import logging

from django.db.models import Q
from django.http import JsonResponse
from openlink.core.models import Mapping, TaskInfo
from openlink.core.serializers import TaskinfoSerializer
from rest_framework import permissions, viewsets


class TaskinfoViewSet(viewsets.ReadOnlyModelViewSet):
    permission_classes = [permissions.IsAuthenticated]
    queryset = TaskInfo.objects.all()
    serializer_class = TaskinfoSerializer

    def get_queryset(self):
        queryset = TaskInfo.objects.all()
        project_id = None
        max_lenght = None
        delta_minutes = None
        if self.request.query_params.get("project_id"):
            project_id = int(self.request.query_params.get("project_id"))
        if self.request.query_params.get("max_lenght"):
            max_lenght = int(self.request.query_params.get("max_lenght"))
        if self.request.query_params.get("delta_minutes"):
            delta_minutes = int(self.request.query_params.get("delta_minutes"))
        if project_id is not None:
            queryset = queryset.filter(project__id=project_id)
        if delta_minutes is not None:
            creation_time = datetime.datetime.now() - datetime.timedelta(
                minutes=delta_minutes
            )
            queryset = queryset.filter(
                Q(start_date__gte=creation_time)
                | Q(status="queued")
                | Q(status="started")
            )
        if max_lenght is not None:
            queryset = queryset.order_by("-start_date")[:max_lenght]
        return queryset


class MappingViewSet(viewsets.ViewSet):
    def list(self, request):
        mapping_id = self.request.query_params.get("item_id")
        res = mapping_id.strip("][").split(", ")
        all_results = {}
        list_result = []
        for obj in res:
            dict = {}
            try:
                mapping_object = Mapping.objects.filter(
                    foreign_id_obj__id=obj, type="data"
                )
            except Exception as e:
                logging.debug(e)
                continue
            if mapping_object:
                connector = mapping_object[0].tool_id.get_connector(
                    self.request.session["vault_token"]
                )
                has_access = connector.check_file_access(mapping_object[0].object_id)
                dict["id"] = mapping_object[0].id
                dict["access"] = has_access
                list_result.append(dict)

        all_results["results"] = list_result
        data = json.dumps(all_results)
        return JsonResponse(data, safe=False)

openlink/core/views/users.py
import logging

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from mozilla_django_oidc.auth import OIDCAuthenticationBackend
from openlink.core.forms import AddProjectUserForm
from openlink.core.models import MappingProjectUser, Project

logger = logging.getLogger(__name__)


class OpenLinkOIDCAuthenticationBackend(OIDCAuthenticationBackend):
    def create_user(self, claims):
        user = super(OpenLinkOIDCAuthenticationBackend, self).create_user(claims)
        user.username = claims.get("preferred_username", "")
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user

    def update_user(self, user, claims):
        user.first_name = claims.get("given_name", "")
        user.last_name = claims.get("family_name", "")
        user.save()
        return user


@login_required
def get_access_level(request, project_id):
    # return current user access level for a given project
    access_level = ""
    user = request.user
    try:
        projects_list_user = Project.objects.get(
            author__user=request.user, id=project_id
        )
    except Project.DoesNotExist:
        projects_list_user = None
    if projects_list_user:
        access_level = str("administrator")
    proj_map = (
        MappingProjectUser.objects.filter(user__user=user)
        .filter(project__id=project_id)
        .values()
    )
    if proj_map.exists():
        for value in proj_map:
            access_level = value["role"]
    return access_level


@login_required
def add_user_mapping(request, *args, **kwargs):
    # Select a user to be map to the current project
    current_user = request.user
    current_proj = kwargs["project_id"]
    data_type = "project"
    mpu_list = MappingProjectUser.objects.filter(project__id=current_proj)
    project = get_object_or_404(Project, id=current_proj)

    if request.method == "POST":
        form = AddProjectUserForm(request.POST)
        user_mapping = form.save(commit=False)
        user_mapping.name = str(current_proj) + "_" + str(form.cleaned_data.get("user"))
        user_mapping.project = project
        user_mapping.save()
        messages.info(request, "User " + str(form.cleaned_data.get("user")) + " added")

        return HttpResponseRedirect(
            reverse("core:add_user_mapping", args=[current_proj])
        )

    else:
        form = AddProjectUserForm()

    return render(
        request,
        "mapping/add_user_mapping.html",
        {
            "form": form,
            "current_proj": current_proj,
            "data_type": data_type,
            "current_user": current_user,
            "data_type": data_type,
            "mpu_list": mpu_list,
            "project": project,
        },
    )

openlink/templates/base.html
{% load static %}
{% load guardian_tags %}
<!DOCTYPE html>
<html lang="en">
<head>
    {% comment %} html header {% endcomment %}
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <title>
        {% block title %}
            OpenLink
        {% endblock %}
    </title>

    <meta http-equiv="content-type" content="text/html; charset=utf-8" />

    <meta name="description" content=" content=" {% block meta-description %} OpenLink will establish specialized
            gateways between the various data management tools throughout the data lifecycle by exploiting their respective
        APIs, while providing a cross-cutting view of their data to the research teams. " {% endblock %}" />
    <link rel="shortcut icon" type="image/png" href="{% static "images/favicon.ico" %}" />

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
    {% comment %} Our Custom CSS {% endcomment %}
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    <link rel="stylesheet" href="{% static 'css/introjs.css' %}">
    {% comment %} <link rel="stylesheet" href="{% static 'css/introjs-modern.css' %}"> {% endcomment %}

        <link rel="stylesheet" href="{% static 'css/openlink.css' %}">
        <link rel="stylesheet" href="{% static 'css/generique.css' %}">
        <link rel="stylesheet" href="{% static 'css/bootstrap-tagsinput.css' %}">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.0.13/css/all.css">
        {% block custom_css %}
            <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap.min.css">
            <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.2.1/themes/default/style.min.css" />
        
        
        
        
        {% endblock %}
    
        {% comment %} js imports {% endcomment %}
        {% comment %} jQuery CDN - Slim version (=without AJAX) {% endcomment %}
        <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
        {% comment %} Popper.JS {% endcomment %}
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.0/umd/popper.min.js"
            integrity="sha384-cs/chFZiN24E4KMATLdqdvsezGxaGsi4hLGOzlXwp5UZB1LY//20VyM2taTB4QvJ" crossorigin="anonymous">
        </script>
        {% comment %} Bootstrap JS {% endcomment %}
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js">
        </script>
    
        {% comment %} Font Awesome JS {% endcomment %}
        <script defer src="https://use.fontawesome.com/releases/v5.15.4/js/solid.js"
            integrity="sha384-/BxOvRagtVDn9dJ+JGCtcofNXgQO/CCCVKdMfL115s3gOgQxWaX/tSq5V8dRgsbc" crossorigin="anonymous">
        </script>
        <script defer src="https://use.fontawesome.com/releases/v5.15.4/js/fontawesome.js"
            integrity="sha384-dPBGbj4Uoy1OOpM4+aRGfAOc0W37JkROT+3uynUgTHZCHZNMHfGXsmmvYTffZjYO" crossorigin="anonymous">
        </script>
    
    
    <script src="{% static 'js/mdb.min.js' %}"></script>
    <script src="{% static 'js/modules/treeview.min.js' %}"></script>
    <script src="{% static 'js/modules/animations-extended.min.js' %}"></script>
    <script src="{% static 'js/bootstrap-tagsinput.min.js' %}"></script>
    <script src="{% static 'js/intro.min.js' %}"></script>

    <script src="https://cdn.jsdelivr.net/npm/darkmode-js@1.5.5/lib/darkmode-js.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/js-cookie@rc/dist/js.cookie.min.js"></script>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.3.11/jstree.min.js"></script>

</head>
<body>
    {% include 'nav.html' %}

<div id="alert">
<div id="message">
    {% for message in messages %}
        {% if message.extra_tags == "multiple" %}
    <ul class="alert alert-{{ message.level_tag }} mb-0 alert-dismissible fade show alert-ul alert-fixed" style="cursor: pointer;"
        role="alert"> {{ message }} <i class="chevron-up">&#x2303;</i>  <i class="chevron-down" style="display: None;">&#x2304;</i>
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <div class="alert-progress active" role="progressbar">
                    <div id="box"></div>
                </div>
        {% else %}
            <li class="alert alert-{{ message.level_tag }} mb-0 alert-dismissible fade show alert-li" style="list-style-type: none;" role="alert">
                <span>{{ message }}</span>
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <div class="alert-progress active" role="progressbar">
                    <div id="box"></div>
                </div>
            </li>
        {% endif %}
    {% endfor %}
        </ul>
</div>
</div>

    <div class="container">
        {% block content %}{% endblock %}
    </div>

    <script type="text/javascript" charset="utf8" src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js">
    </script>
    <script>
        var timeoutId = '';
        $(document).ready(function () {
            var duration = 7000;
            var st = new Date().getTime();
            var interval = setInterval(function() {
                var diff = Math.round(new Date().getTime() - st),
                val = Math.round(diff / duration * 100);
                val = val > 100 ? 100 : val;
                $("#box").css("width", val + "%");
                if (diff >= duration) {
                clearInterval(interval);
                }
            }, 100);

            $(".alert-ul").find('li').slideToggle();
            timeoutId = setTimeout(function(){
                $('.alert-ul,.alert-li').fadeOut('fast');}, duration);
                });
            $('.alert-ul,.alert-li').click(function() {
                clearTimeout(timeoutId);
                $(".chevron-up").toggle();
                $(".chevron-down").toggle();
                $('.alert-ul').find('li').slideToggle();
            });
    </script>
    <script>
        $(document).ready(function () {
            $('#table.table').DataTable({
                searching: true,
                info: false
            });
        });
    </script>
    <script>
        $(document).ready(function () {
            $('[data-toggle="popover"]').popover();
        });
    </script>
    <script>
        $(document).ready(function () {

            $('#sidebarCollapse').on('click', function () {
                $('#sidebar').toggleClass('active');
            });

        });
    </script>
    {{ redirect_to_login_immediately }}
    {{ logout_on_tabs_closed }}
    {% comment %} <footer>
        {%if debug %}
            {{ request.get_full_path }}
            <br>
            {{request.resolver_match.view_name}}
            <br>
            {{request.resolver_match.url_name}}
            <br>
            {{request.resolver_match}}
            <br>
            {{request.resolver_match.func}}
            <br>
            {{request.resolver_match.route}}
            <br>
        {%endif%}
    </footer> {% endcomment %}
</body>

</html>

openlink/templates/nav.html
{% load static %}
{% load guardian_tags %}
{% load get_version %}

<div class="wrapper">
    {% comment %} Sidebar {% endcomment %}
    <nav id="sidebar">
        <div class="sidebar-header">
            <h3><a href="{% url 'core:projects' %}"><i class="fa fa-link fa-1x"></i> OpenLink</a></h3>
            <a href="{% url 'core:projects' %}"><strong><i class="fa fa-link fa-1x"></i></strong></a>
        </div>

        <ul class="list-unstyled components">
            <li class="active">
                <a href="{% url 'core:projects' %}">
                    <i class="fas fa-home"></i>
                    Home
                </a>
            </li>
            <li>
                <a href="{% url 'core:about' %}">
                    <i class="fas fa-info-circle"></i>
                    About
                </a>
            </li>
        </ul>

        <ul class="list-unstyled components">
            {% if user.is_authenticated %}
                <li>
                    <a href="{% url 'logout' %}"><i class="fas fa-sign-out-alt"></i> Logout</a>
                </li>
                <li>
                    <a href="{% url 'core:user-profile' user.username %}"><i class="fas fa-user"></i> {{ user.get_username }}</a>
                </li>
                <li>
                    <a href="{% url 'admin:index' %}"><i class="fas fa-unlock-alt"></i> Admin</a>
                </li>
            {% else %}
                <li>
                    <a href="{% url 'login' %}"><i class="fas fa-sign-in-alt"></i> Login</a>
                </li>
                <li>
                    <a href="{% url 'admin:index' %}"><i class="fas fa-unlock-alt"></i> Admin</a>
                </li>
            {% endif %}

        </ul>
        <ul class= "list-unstyled components">
        <li>
            <a href="{% url 'core:contact' %}">
                <i class="fas fa-envelope-open"></i>
                Contact
            </a>
        </li>
        <br>
        <a href="https://www.france-bioinformatique.fr/" target="_blank"> <img src="{% static 'images/logo-ifb-blanc.svg' %}" alt="IFB"
                width="90" style="margin-left: 5%;"></a>
        <br>
        <br>
        <a href="http://www.igbmc.fr/" target="_blank"> <img src="{% static 'images/IGBMC_2012_logo.png' %}" alt="IGBMC"
                width="60" style="margin-left: 5%;"></a>
        <br>
        <ul>
            <a href="https://gitlab.com/ifb-elixirfr/openlink/-/tree/dev"><span class='version'>{{"Version "|get_version}}</span></a>
        </ul>
    </nav>
    <div id="content">

        <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <div style="padding-right: 0px; margin-right: 0px;" class="row col-sm-12">
                <div class="col-xs-1">
                    <button type="button" id="sidebarCollapse" class="btn btn-primary">
                        <i class="fas fa-align-left"></i>
                        <span></span>
                    </button>
                </div>
                <div class="col-sm-7 text-left">
                    {% block messages %}
                        {% if project %}
                            <h4 class="display-titre"><a
                                href="{% url 'core:projects-details' project.id %}"><i
                                    class="fas fa-desktop fa-xs"></i> {{ project.name }}</a>&nbsp;
                                    <a class="edit_card btn btn-outline-secondary btn-sm"
                                href="{% url 'core:edit-project' project_id=project.id %}">Edit</a>&nbsp;
                                {% get_obj_perms request.user for project as "project_perms" %}
                                {% if "manage_user" in project_perms %}
                                    <a class="user_card btn btn-outline-secondary btn-sm "
                                        href="{% url 'core:mapping_project_user' project_id=project.id %}">Manage Users</a>
                                {% else %}
                                    <div class="user_card disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                                        data-placement="right" title="Action not available" data-container="body" data-html="true"
                                        data-content="You don't have sufficient permissions to  <br/> <strong>manage users</strong>.">
                                        <button class="btn btn-outline-secondary btn-sm" type="button" disabled>Manage User</button>
                                    </div>
                                {% endif %}

                                {% if "manage_tool" in project_perms %}
                                    <a class="tool_card btn btn-outline-secondary btn-sm"
                                        href="{% url 'core:tools-project' project.id %}">Manage Tools</a>
                                {% else %}
                                    <div class="tool_card disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                                        data-placement="right" title="Action not available" data-container="body" data-html="true"
                                        data-content="You don't have sufficient permissions to  <br/> <strong>manage tools</strong>.">
                                        <button class="btn btn-outline-secondary btn-sm" type="button" disabled>Tools</button>
                                    </div>
                                {% endif %}

                            </h4>
                        {% endif %}
                    {% endblock %}
                </div>
                <div style="padding-right: 0px; margin-right: 0px;" class="col-sm-4 text-right">

                    {% if project %}
                        {% get_obj_perms request.user for project as "project_perms" %}
                        {% if "change_project" in project_perms %}
        
                            <a class="add_investigation_card btn btn-outline-primary btn-sm"
                                href="{% url 'core:add-investigation' project.id %}">Add investigation</a>
                        {% else %}
                            <div class="disabled-button-wrapper" data-toggle="popover" data-trigger="hover"
                                data-placement="right" title="Action not available" data-container="body" data-html="true"
                                data-content="You don't have sufficient permissions to  <br/> <strong>add investigation</strong>.">
                                <button class="add_investigation_card btn btn-outline-primary" type="button" disabled>Add investigation</button>
                            </div>
                        {% endif %}</h4>
                    {% endif %}
                </div>
            </div>

        </nav>